/**************************************************************************
 * $Id: main.cpp 1.2 Thu, 18 Feb 1999 16:48:37 +0100 samo $
 * $ReleaseVersion: 1.3.1 $
 *
 * This file is part of SampLin data acquisition software
 * Copyright (C) 1997,98 Samuel Kvasnica
 *
 * SampLin is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * SampLin is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file LICENSE) along with SampLin package; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************************/

#include <samplin.h>

#include "devices.h"
#include <cnflib.h>

#include <signal.h>

#include <DeviceDlg.h>

//SamplinCurve *clipboard_curve;

main( int argc, char ** argv )
{
   int ret;
   DeviceDlg *ddlg;
   
   KApplication a( argc, argv, PACKAGE);

   readConfig();
   writeConfig();
   createDirs();

   ddlg = new DeviceDlg(NULL, "Configure devices");
   if(ddlg->setFile(cnf.cnf_dir+cnf.devices_file));

   else {
      fprintf(stderr,"Can't open device configuration '%s'\n",(cnf.cnf_dir+cnf.devices_file).data());
      exit(1);
   };
   
   a.setMainWidget(ddlg);      
   ddlg->show();
//   a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
//   kapp->quit();

   exit(0);

//   ret=a.exec();
   return (ret);
}

